unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, StdCtrls, CRVData, RVTypes;

type
  TForm1 = class(TForm)
    RichView1: TRichView;
    RVStyle1: TRVStyle;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure RichView1SaveItemToFile(Sender: TCustomRichView;
      const Path: TRVUnicodeString; RVData: TCustomRVData; ItemNo: Integer;
      SaveFormat: TRVSaveFormat; var OutStr: TRVUnicodeString;
      var DoDefault: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// A4 width in twips (1 inch = 1440 twips)
const A4Width = 11906;
      A4Height = 16838;

procedure CreateRTFWithSections(const RVFFiles: array of String;
  const IsLandscape: array of Boolean;
  const RTFFile: String; rv: TCustomRichView);
var i, ParaNo: Integer;
    Stream: TFileStream;
begin
  rv.Clear;
  with rv.Style do begin
    TextStyles.Clear;
    TextStyles.Add;
    with TextStyles.Add do begin
      Options := [rvteoRTFCode];
    end;
    ParaStyles.Clear;
    ParaStyles.Add;
    ListStyles.Clear;
  end;
  ParaNo := 0;
  for i := Low(RVFFiles) to High(RVFFiles) do
    try
      Stream := TFileStream.Create(RVFFiles[i], fmOpenRead);
      try
        if i<>0 then begin
          rv.AddNL('\sect\sectd', 1, ParaNo);
          ParaNo := -1;
        end;
        if IsLandscape[i] then
          rv.AddFmt('\lndscpsxn\pgwsxn%d\pghsxn%d', [A4Height, A4Width], 1, ParaNo)
        else
          rv.AddFmt('\pgwsxn%d\pghsxn%d', [A4Width, A4Height], 1, ParaNo);
        ParaNo := -1;
        rv.InsertRVFFromStream(Stream, rv.ItemCount);
      finally
        Stream.Free;
      end;
    except
      rv.AddNL('Error loading file', 0, 0);
    end;
  rv.SaveRTF(RTFFile, False);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateRTFWithSections(
    ['doc1.rvf', 'doc2.rvf', 'doc3.rvf'],
    [False, True, False], 'Result.rtf', RichView1);
  RichView1.Format;
end;

procedure TForm1.RichView1SaveItemToFile(Sender: TCustomRichView;
  const Path: TRVUnicodeString; RVData: TCustomRVData; ItemNo: Integer;
  SaveFormat: TRVSaveFormat;
  var OutStr: TRVUnicodeString; var DoDefault: Boolean);
begin
  if RVData.GetItemStyle(ItemNo)=1 then
    Include(RVData.State, rvstRTFSkipPar);
  DoDefault := True;
end;

end.
